	.dbfile C:\iccv7arm\MIC244~1\MicroBoltWatchdog.c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Delay -> R6
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 38
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltWatchdog.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 9/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
;  
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; 
; #include "MicroBoltWatchdog.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 47
; 	unsigned int Delay;
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 54
; 
; /*
; |-------------------------
; | Configure MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 55
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 57
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 64
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+8
	ldr R5,LIT_main+12
	str R4,[R5,#0]
	.dbline 65
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 66
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 73
; 
; /*
; |-------------------------
; | Configure PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+24
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 74
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+28
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 75
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 76
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 83
; 
; /*
; |-------------------------
; | Configure PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 90
; 
; /*
; |-------------------------
; | Configure GPIO 
; |-------------------------
; */ 
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port (Configured via Imagecraft App builder)
	mov R4,#0
	ldr R5,LIT_main+40
	str R4,[R5,#0]
	.dbline 91
;   PCB_PINSEL1=0x55400000;
	ldr R4,LIT_main+44
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 93
; 
;   GPIO_IODIR=(0x00000000<<16)|                  // Make all inputs to start with
	mov R4,#0
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 96
; 	     0x00000000;
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+52
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 103
; 
; /*
; |-------------------------
; | Configure Watchdog 
; |-------------------------
; */ 
;   WD_WDTC=0x003EF148;                           // Watchdog timeout set to 1 second
	ldr R4,LIT_main+56
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 104
;   WD_WDMOD=0x00000003;                          // Watchdog interrupts and causes reset
	mov R4,#3
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 105
;   WD_WDFEED=0xaa;                               // Start the watchdog
	mov R4,#170
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 106
;   WD_WDFEED=0x55;
	mov R4,#85
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 108
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 110
; 
;   GPIO_IOCLR = MICROBOLT_LED;                   // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 112
	mov R6,#0
	b L5
L2:
	.dbline 112
L3:
	.dbline 112
	add R6,R6,#1
L5:
	.dbline 112
; 
;   for (Delay = 0; Delay < 3000000; Delay++);    // Delay for a few (Shows watchdog reset if applicable)
	ldr R4,LIT_main+76
	cmp R6,R4
	blo L2
	b L7
L6:
	.dbline 121
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */ 
; 
;   while(1)                                      // Do this forever
;     {
	.dbline 122
;     KickTheDog();                               // Kick the watchdog (Comment this line out to see watchdog reset every second)
	bl _KickTheDog
	.dbline 124
; 
;     GPIO_IOSET = MICROBOLT_LED;                 // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 125
	mov R6,#0
	b L12
L9:
	.dbline 125
L10:
	.dbline 125
	add R6,R6,#1
L12:
	.dbline 125
;     for (Delay = 0; Delay < 500000; Delay++);   // Delay for a few
	ldr R4,LIT_main+84
	cmp R6,R4
	blo L9
	.dbline 126
;     GPIO_IOCLR = MICROBOLT_LED;                 // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 127
	mov R6,#0
	b L16
L13:
	.dbline 127
L14:
	.dbline 127
	add R6,R6,#1
L16:
	.dbline 127
	ldr R4,LIT_main+84
	cmp R6,R4
	blo L13
	.dbline 128
L7:
	.dbline 120
	b L6
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD 4125000
	DCD -536870908
	DCD -536870912
	DCD -536870904
	DCD -536707060
	DCD 3000000
	DCD -536707068
	DCD 500000
	.dbsym r Delay 6 i
	.dbend
	EXPORT _KickTheDog
	.dbfunc e KickTheDog _KickTheDog fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_KickTheDog:
	.dbline -1
	.dbline 148
;     for (Delay = 0; Delay < 500000; Delay++);   // Delay for a few               
;     }
;   } 
; 
; /*
; |----------------------------------------------------
; |     Functions
; |----------------------------------------------------
; */ 
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   KickTheDog
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Reset the watchdog timer
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void KickTheDog(void)
;   {
	.dbline 149
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 151
; 
;   WD_WDFEED=0xaa;                               // Reset the watchdog with back to back writes
	mov R0,#170
	ldr R1,LIT_KickTheDog+0
	str R0,[R1,#0]
	.dbline 152
;   WD_WDFEED=0x55;
	mov R0,#85
	ldr R1,LIT_KickTheDog+0
	str R0,[R1,#0]
	.dbline 154
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline -2
L17:
	mov R15,R14
	.dbline 0 ; func end
LIT_KickTheDog:
	DCD -536870904
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 170
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 171
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 172
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 173
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 174
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 175
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L18:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	END
